## Common makefile setting for linux gcc & MinGW gcc

# ++Skype release number
VERSION_NUM = 1.10

# ++Skype release date
VERSION_DATE = "Oct 19 2006"

# Symbolic name of this ++Skype release
VERSION_ALIAS = "Icecream"

## DON'T CHANGE ANYTHING AFTER THIS LINE
## IF YOU ARE NOT REALLY KNOW WHAT YOU ARE DOING

INCLS_COMMON=-I$(BOOST_INCLUDES) -I$(LOKI_INCLUDES)
CFLAGS  = -O3 -fPIC -Wall -MMD -DVERSION_NUM=\"${VERSION_NUM}\" -DVERSION_ALIAS=\"${VERSION_ALIAS}\" -DVERSION_DATE=\"${VERSION_DATE}\" 

# Common Object files required for skype library building
LIB_O_COMMON = $(patsubst %.cpp,%.obj,$(wildcard *.cpp))
LIB_O_COMMON_PROXY = $(patsubst %.cpp,%.opp,$(wildcard *.cpp))

.PHONY: clean doc ref install_common clean_common tests

# Cscope references
ref:
	cscope -b *.cpp  

ifneq ($(strip $(wildcard *.d)),)
include $(wildcard *.d)
endif

ifneq ($(strip $(wildcard unix/*.d)),)
include $(wildcard unix/*.d)
endif

ifneq ($(strip $(wildcard win/*.d)),)
include $(wildcard win/*.d)
endif

doc:	
	$(RM) -r docs
	$(DOXYGEN)

install_common: 
	$(MKDIR) -p $(INSTALL_DIR)/lib
	$(MKDIR) -p $(INSTALL_DIR)/h
	$(FIND) ./h/ -maxdepth 1 -name "*.h" -exec $(INSTALL) -m 0640 {} $(INSTALL_DIR)/h \;
	$(FIND) ./h/ -maxdepth 1 -name "*.tcc" -exec $(INSTALL) -m 0640  {} $(INSTALL_DIR)/h \;
	$(MKDIR) -p $(INSTALL_DIR)/h/unix
	$(MKDIR) -p $(INSTALL_DIR)/h/win
	$(FIND) ./h/unix -maxdepth 1 -name "*.h" -exec $(INSTALL) -m 0640  {} $(INSTALL_DIR)/h/unix \;
	$(FIND) ./h/unix -maxdepth 1 -name "*.tcc" -exec $(INSTALL) -m 0640  {} $(INSTALL_DIR)/h/unix \;
	$(FIND) ./h/win -maxdepth 1 -name "*.h" -exec $(INSTALL) -m 0640  {} $(INSTALL_DIR)/h/win \;
	$(FIND) ./h/win -maxdepth 1 -name "*.tcc" -exec $(INSTALL) -m 0640  {} $(INSTALL_DIR)/h/win \;

clean_common:
	-$(RM) *.obj *.d *.o *.opp
	-$(RM) unix/*.obj unix/*.d unix/*.opp
	-$(RM) win/*.obj win/*.d win/*.opp
	-$(FIND) . -name core -exec rm -f {} ';' 
	-$(RM) -r docs

