#include "h/Audio.h"
#include "h/SkypeConnection.h"

#include "SkypeTest.h"

typedef StreamLogger<LvlTimeLogPrefix> MyLogger_t;
MyLogger_t logger(std::cout);
LogFunc_t lf(&logger, &MyLogger_t::Do);
using namespace Ice;

void DefaultCallback(const std::string& s)
{
	fprintf(stdout, "%s: '%s'\n", __FUNCTION__, s.c_str());	
};


//--- Tutorial example code ---
void ObjChanged(AudioSettings& au, const AudioAttrs_t& attr, const std::string& value)
{ 
	const AudioSettings::AttrsDescription_t desc;
	std::cout << "New value of the attribute '" << desc[attr] << "' is '";
	std::cout << value << "'" << std::endl;
};
//--- End of tutorial example code ---

int main(int argc, char* argv[])
{
    SkypeConnection sk(argv[0], SimpleHandler_t(DefaultCallback), lf);
    sk.Attach();
    sk << DisableIds << "PROTOCOL 99" << flush << EnableIds;
	AudioSettings au(sk, sk.GetLog());

//--- Tutorial example code ---
	typedef AudioSettings::Watchers_t AWatchers_t;
	AWatchers_t::AttrSet_t attrs ;
	attrs.insert(auAudioOut);
	attrs.insert(auAudioIn);
	au.GetWatchers().RegisterWatcher(attrs, ObjChanged);
//--- End of tutorial example code ---

    sk << DisableIds << "SET AUDIO_IN" << flush << EnableIds;
    sk << DisableIds << "SET AUDIO_OUT" << flush << EnableIds;

	const boost::posix_time::seconds tm(1);
	ProcessSkypeMsgs(sk, tm);

	return 0;
}
